package dnddemo2;
import java.awt.Color;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;

public class TextColor implements Transferable {
    
    private String text;
    private Color color;
    private DataFlavor[] flavors;
    
    public TextColor(String text, Color color) {
        String colorMimeType = 
                DataFlavor.javaJVMLocalObjectMimeType +
                ";class=java.awt.Color";
        DataFlavor colorFlavor = null;
        try {
            colorFlavor = new DataFlavor(colorMimeType);
        } catch (ClassNotFoundException e) { 
        }
        flavors = new DataFlavor[2];
        flavors[0] = DataFlavor.stringFlavor;
        flavors[1] = colorFlavor;
        this.text = text;
        this.color = color;
    }

    public DataFlavor[] getTransferDataFlavors() {
        return (DataFlavor[])flavors.clone();
    }
    public boolean isDataFlavorSupported(DataFlavor flavor) {
        for (int i = 0; i < flavors.length; i++) {
    	    if (flavor.equals(flavors[i])) {
    	        return true;
    	    }
    	}
    	return false;
    }
    public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
        if (flavor.equals(flavors[0])) {
            return text;
        } else if (flavor.equals(flavors[1])) {
            return color;
        } else {
            throw new UnsupportedFlavorException(flavor);
        }
    }
}
